from LetterTemplate import KLetterTemplate


class ltTemplate(KLetterTemplate):

    def title(self):
        import sys
        import os
        try:
            from reportlab.pdfbase import pdfmetrics
            from reportlab.pdfbase.ttfonts import TTFont
            myFontFile = os.path.join(os.path.dirname(sys.argv[0]), "..", "lib", "letters", "standard", "rina.ttf")
            pdfmetrics.registerFont(TTFont('Rina', myFontFile))
        except:
            pass
        name = "Kumula Standard Template"
        return name


    def wantedInfos(self):
        infos = (
            ("subject",  "Subject",          "edit"),
            ("yourdate", "Your letter from", "date"),
            ("yoursign", "Your sign",        "edit"),
            ("oursign",  "Our sign",         "edit"),
            ("ourdate",  "Date",             "date"),
        )
        return infos


    def pageSize(self):
        from reportlab.lib.pagesizes import A4
        return A4


    def textStyle(self):
        myStyle = KLetterTemplate.textStyle(self)
        myStyle.fontName = "Helvetica"
        myStyle.fontSize = 10
        myStyle.leading = 12
        return myStyle


    def drawFooter(self, canvas):
        from reportlab.lib.units import mm

        canvas.setStrokeColorRGB(0.5, 0.0, 0.0)
        canvas.setFillColorRGB(0.2, 0.2, 0.2)
        canvas.line(0*mm, 23*mm, 210*mm, 23*mm)
        canvas.setFont('Helvetica-Bold', 8)
        canvas.drawString( 20*mm, 15*mm, "Kumula Business Suite")
        canvas.setFont('Helvetica', 8)
        canvas.drawString( 20*mm, 11.5*mm, "Teststreet 13")
        canvas.drawString( 20*mm,  8*mm, "99999 Testcity")
        canvas.setFont('Helvetica-Bold', 8)
        canvas.drawString( 70*mm, 15*mm, "Phone:")
        canvas.drawString( 70*mm, 11.5*mm, "Fax:")
        canvas.drawString( 70*mm,  8*mm, "Mobile:")
        canvas.setFont('Helvetica', 8)
        canvas.drawString( 85*mm, 15*mm, "+49 (0) 999 123456")
        canvas.drawString( 85*mm, 11.5*mm, "+49 (0) 999 654321")
        canvas.drawString( 85*mm,  8*mm, "+49 (0) 177 987654")
        canvas.setFont('Helvetica-Bold', 8)
        canvas.drawString(125*mm, 15*mm, "E-Mail:")
        canvas.setFont('Helvetica', 8)
        canvas.drawString(125*mm, 11.5*mm, "info@kumula.org")
        canvas.setFont('Helvetica-Bold', 8)
        canvas.drawString(165*mm, 15*mm, "Big Bank International")
        canvas.setFont('Helvetica', 8)
        canvas.drawString(165*mm, 11.5*mm, "SWIFT 0815 4711")
        canvas.drawString(165*mm,  8*mm, "Acc.No. 1313 1313")


    def doFirstPage(self, canvas, doc):
        from reportlab.lib.units import mm
        import sys
        import os

        canvas.saveState()
        myWaterMarkFile = os.path.join(os.path.dirname(sys.argv[0]), "..", "lib", "letters", "standard", "watermark.gif")
        canvas.drawImage(myWaterMarkFile, 10*mm, 52*mm, 190*mm, 112*mm)
        myLogoFile = os.path.join(os.path.dirname(sys.argv[0]), "..", "lib", "letters", "standard", "logo.gif")
        canvas.drawImage(myLogoFile, 110*mm, 255*mm, 90*mm, 32*mm)
        canvas.setFont('Helvetica', 8)
        canvas.setStrokeColorRGB(0.5, 0.0, 0.0)
        canvas.setFillColorRGB(0.2, 0.2, 0.2)
        canvas.line(20*mm, 245*mm, 100*mm, 245*mm)
        canvas.drawString(20*mm, 246*mm, "Kumula Business Suite  -  Teststreet 13  -  99999 Testcity")

        canvas.setFont('Helvetica-Bold', 12)
        canvas.drawString(20*mm, 190*mm, self.metainfo["subject"])
        canvas.setFont('Helvetica', 10)
        canvas.drawString(140*mm, 240*mm, "Your letter from:")
        canvas.drawString(140*mm, 235*mm, "Your sign:")
        canvas.drawString(140*mm, 225*mm, "Our sign:")
        canvas.drawString(170*mm, 240*mm, self.metainfo["yourdate"])
        canvas.drawString(170*mm, 235*mm, self.metainfo["yoursign"])
        canvas.drawString(170*mm, 225*mm, self.metainfo["oursign"])
        canvas.drawString(140*mm, 215*mm, "Nuremberg, %s" % self.metainfo["ourdate"])
        pos = 240
        for lineNr in range(self.recinfo.count()):
            line = self.recinfo[lineNr]
            if (line):
                line = '%s' % line
                if (lineNr == 1):
                    canvas.setFont('Helvetica-Bold', 10)
                else:
                    canvas.setFont('Helvetica', 10)
                canvas.drawString(20*mm, pos*mm, line)
            pos = pos - 5
        self.drawFooter(canvas)
        canvas.restoreState()


    def doLaterPages(self, canvas, doc):
        from reportlab.lib.units import mm
        import sys
        import os

        canvas.saveState()
        pageHeight = self.pageSize()[1]
        pageWidth  = self.pageSize()[0]

        myWaterMarkFile = os.path.join(os.path.dirname(sys.argv[0]), "..", "lib", "letters", "standard", "watermark.gif")
        canvas.drawImage(myWaterMarkFile, 10*mm, 102*mm, 190*mm, 112*mm)
        self.drawFooter(canvas)
        canvas.restoreState()


    def firstFrames(self):
        from reportlab.platypus import Frame
        from reportlab.lib.units import mm
        firstFrames = [Frame(20*mm, 37*mm, 170*mm, 140*mm, leftPadding=0, rightPadding=0, topPadding=0, bottomPadding=0)]
        return firstFrames


    def laterFrames(self):
        from reportlab.platypus import Frame
        from reportlab.lib.units import mm
        laterFrames = [Frame(20*mm, 20*mm, 170*mm, 260*mm, leftPadding=0, rightPadding=0, topPadding=0, bottomPadding=0)]
        return laterFrames


